var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F08100;
(function (F08100) {
    var FDocument = (function (_super) {
        __extends(FDocument, _super);
        function FDocument(id, version, oldVersion) {
            var _this = _super.call(this, id, version, oldVersion) || this;
            _this._tableP1 = null;
            _this._tableP2 = null;
            _this._tableP3 = null;
            _this._tableP4 = null;
            _this._tableP5 = null;
            _this._tableP4Npa = null;
            _this._subsSprTable = null;
            _this._targetSubsidiesSprTable = null;
            _this._uniqSubsTableP2 = null;
            _this._analyticsDataTable = null;
            _this._analyticSheet = null;
            _this._p1Sheet = null;
            _this._sheetP2 = null;
            _this._sheetP3 = null;
            _this._sheetP4 = null;
            _this._sheetP5 = null;
            _this._sheetNpa2 = null;
            _this._sheetNpa3 = null;
            _this._sheetNpa4 = null;
            _this._sheetNpa5 = null;
            _this._tableRules = new F08100.TableRules(_this);
            _this._interfaceRules = new F08100.InterfaceRules(_this);
            _this._updateRules = new F08100.UpdateRules(_this);
            _this._exportRules = new F08100.ExportRules(_this);
            _this._importRules = new F08100.ImportRules(_this);
            return _this;
        }
        Object.defineProperty(FDocument.prototype, "TotalTable", {
            get: function () {
                return this.TableP1;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "TableP2", {
            get: function () {
                if (this._tableP2 == null) {
                    this._tableP2 = new F08100.P2Table("F08_100_R2", this, this.TableP1);
                }
                return this._tableP2;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "TableP3", {
            get: function () {
                if (this._tableP3 == null) {
                    this._tableP3 = new F08100.P3Table("F08_100_R3", this, this.TableP1);
                }
                return this._tableP3;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "TableP4", {
            get: function () {
                if (this._tableP4 == null) {
                    this._tableP4 = new F08100.P4Table("F08_100_R4", this, this.TableP1);
                }
                return this._tableP4;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "TableP5", {
            get: function () {
                if (this._tableP5 == null) {
                    this._tableP5 = new F08100.P5Table("F08_100_R5", this, this.TableP1);
                }
                return this._tableP5;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "TableRules", {
            get: function () {
                return this._tableRules;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "InterfaceRules", {
            get: function () {
                return this._interfaceRules;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "UpdateRules", {
            get: function () {
                return this._updateRules;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "ExportRules", {
            get: function () {
                return this._exportRules;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "ImportRules", {
            get: function () {
                return this._importRules;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "TableP1", {
            get: function () {
                if (this._tableP1 == null) {
                    this._tableP1 = new F08100.ObasTableP1("F08_100_R1_SumValues", this);
                }
                return this._tableP1;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "SubsidiesSprTable", {
            get: function () {
                if (this._subsSprTable == null) {
                    this._subsSprTable = new SprTable("subsidies_spr");
                }
                return this._subsSprTable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "TargetSubsidiesSprTable", {
            get: function () {
                if (this._targetSubsidiesSprTable == null) {
                    this._targetSubsidiesSprTable = new SprTable("TargetSubsidies_spr");
                }
                return this._targetSubsidiesSprTable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "P1Sheet", {
            get: function () {
                if (this._p1Sheet == null) {
                    this._p1Sheet = new F08100.P1Sheet("SHT_F08_100_R1", this);
                }
                return this._p1Sheet;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "SheetP2", {
            get: function () {
                if (this._sheetP2 == null) {
                    this._sheetP2 = new F08100.P2GroupSheet(this);
                }
                return this._sheetP2;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "SheetP3", {
            get: function () {
                if (this._sheetP3 == null) {
                    this._sheetP3 = new F08100.P3GroupSheet(this);
                }
                return this._sheetP3;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "SheetP4", {
            get: function () {
                if (this._sheetP4 == null) {
                    this._sheetP4 = new F08100.P4GroupSheet(this);
                }
                return this._sheetP4;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "SheetP5", {
            get: function () {
                if (this._sheetP5 == null) {
                    this._sheetP5 = new F08100.P5Sheet("SHT_F08_100_R5", this);
                }
                return this._sheetP5;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "TableP4Npa", {
            get: function () {
                if (this._tableP4Npa == null) {
                    this._tableP4Npa = new F08100.NpaTable4("F08_100_R4_1", this);
                }
                return this._tableP4Npa;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "SheetNpa2", {
            get: function () {
                if (this._sheetNpa2 == null) {
                    this._sheetNpa2 = new F08100.NpaSheet("SHT_F08_100_R2_2", this, [], 1, [0, 2, 6], true);
                }
                return this._sheetNpa2;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "SheetNpa3", {
            get: function () {
                if (this._sheetNpa3 == null) {
                    this._sheetNpa3 = new F08100.NpaSheet("SHT_F08_100_R3_2", this, [], null, [0, 4]);
                }
                return this._sheetNpa3;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "SheetNpa4", {
            get: function () {
                if (this._sheetNpa4 == null) {
                    this._sheetNpa4 = new F08100.NpaSheet("SHT_F08_100_R4_2", this, [0], null, [1, 2, 6]);
                }
                return this._sheetNpa4;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "SheetNpa5", {
            get: function () {
                if (this._sheetNpa5 == null) {
                    this._sheetNpa5 = new F08100.NpaSheet("SHT_F08_100_R5_2", this, [], 2, [0, 1, 3, 7], true);
                }
                return this._sheetNpa5;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "AnalyticsDataTable", {
            get: function () {
                if (this._analyticsDataTable == null) {
                    this._analyticsDataTable = new AnalyticsKosgu.AnalyticsDataTable("AnalyticsData", this);
                }
                return this._analyticsDataTable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "AnalyticSheet", {
            get: function () {
                if (this._analyticSheet == null) {
                    this._analyticSheet = new AnalyticsKosgu.AnalyticsSheet("SHT_RA", this);
                }
                return this._analyticSheet;
            },
            enumerable: true,
            configurable: true
        });
        return FDocument;
    }(BaseDocumentObject));
    F08100.FDocument = FDocument;
})(F08100 || (F08100 = {}));
